VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Game"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim Contacts() As Contact
Dim NumContacts As Long

Public Sub SetNumContacts(HowMany As Long)
ReDim Preserve Contacts(HowMany)
NumContacts = HowMany
End Sub
Public Sub SetContactPos(Team As Long, whatCon As Long, xPos As Double, yPos As Double, zPos As Double, Dead As Boolean, healthZ As Long)
Contacts(whatCon).xPos = xPos
Contacts(whatCon).yPos = yPos
Contacts(whatCon).zPos = zPos

Contacts(whatCon).Team = Team
Contacts(whatCon).health = healthZ

End Sub
Public Function GetCX(whatC As Variant) As Double
GetCX = Contacts(whatC).xPos

End Function
Public Function getcy(whatC As Variant) As Double
getcy = Contacts(whatC).yPos

End Function
Public Function getCZ(whatC As Variant) As Double
getCZ = Contacts(whatC).zPos

End Function
Public Function GetCT(whatC As Variant) As Long
GetCT = Contacts(whatC).Team

End Function
Public Function GetCLx(xPos As Double, yPos As Double, zPos As Double, OnTeam As Long) As Double
Dim whoClose As Long
whoClose = WhoClosest(xPos, yPos, zPos, OnTeam)
GetCLx = Contacts(whoClose).xPos

End Function
Public Function GetCLy(xPos As Double, yPos As Double, zPos As Double, OnTeam As Long) As Double
Dim whoClose As Long
whoClose = WhoClosest(xPos, yPos, zPos, OnTeam)
GetCLy = Contacts(whoClose).yPos

End Function

Public Function GetCLz(xPos As Double, yPos As Double, zPos As Double, OnTeam As Long) As Double
Dim whoClose As Long
whoClose = WhoClosest(xPos, yPos, zPos, OnTeam)
GetCLz = Contacts(whoClose).zPos

End Function

Public Function OutputLoc(xPos As Double, yPos As Double, zPos As Double, whatFrame As Long) As String
'pointkey { 0 (0 0 0)  "?" }
OutputLoc = " pointkey { " & whatFrame & " ( " & xPos & " " & yPos & " " & zPos & " ) " & Chr(34) & "?" & Chr(34) & " }  "
End Function
Public Function DoSomething(doWhat As String, whatFrame As Long) As String
DoSomething = " namedsequence { " & Chr(34) & doWhat & Chr(34) & " " & whatFrame & " } "
End Function
Public Function FacePos(xPos As Double, yPos As Double, zPos As Double, whatFrame As Long) As String
' pointkey { 0 (0 0 0) (-79.656 41.261 0) (79.656 -41.261 0) "?" }
FacePos = " pointkey { " & whatFrame & " ( " & xPos & " " & yPos & " " & zPos & " ) " & Chr(34) & "?" & Chr(34) & " } "

End Function
Public Function DistFromMe(x1 As Double, y1 As Double, z1 As Double, whatC As Long) As Double
Dim x2 As Double
Dim y2 As Double
Dim z2 As Double
x2 = Contacts(whatC).xPos
y2 = Contacts(whatC).yPos
z2 = Contacts(whatC).zPos
DistFromMe = Sqr((x1 - x2) ^ 2 + (y1 - y2) ^ 2 + (z1 - z2) ^ 2)

End Function
Public Function FaceContact(whatC As Long, whatFrame As Long) As String
FaceContact = " pointkey { " & whatFrame & " (" & Contacts(whatC).xPos & " " & Contacts(whatC).yPos & " " & Contacts(whatC).zPos & ") " & Chr(34) & "?" & Chr(34) & "}"
End Function
Public Function WhoClosest(XP As Double, YP As Double, ZP As Double, OnTeam As Long) As Variant
Dim ClosestSoFar As Double
Dim WhichOne As Long
WhichOne = 0
Dim i As Long

For i = 1 To NumContacts
    If (DistFromMe(XP, YP, ZP, i) < ClosestSoFar Or WhichOne = 0) And Contacts(i).Team = OnTeam And Contacts(i).health > 0 Then
        WhichOne = i
        ClosestSoFar = DistFromMe(XP, YP, ZP, i)
        
    End If
    
Next i
WhoClosest = WhichOne
End Function
Public Function Attack(xPos As Double, yPos As Double, zPos As Double, whatC As Long, myRange As Double, Damage As Long) As Boolean
Dim result As Boolean
result = False
    Avatars(whatC).Maxlife = Avatars(whatC).Maxlife - Damage
    If Avatars(whatC).Maxlife <= 0 Then
        Avatars(whatC).Maxlife = 0
        result = True
    End If
    
MsgBox ("Avatars(" & whatC & ") took " & Damage & " points of damage.  His Health is now at:" & Avatars(whatC).Maxlife & ".  Contact Health at: " & Contacts(whatC).health)
Attack = result

End Function
Public Function MoveToClosest(xPos As Double, yPos As Double, zPos As Double, byWhen As Long, whatTeam As Long) As String
Dim whoClose As Long
Dim TempString As String
whoClose = WhoClosest(xPos, yPos, zPos, whatTeam)
TempString = OutputLoc(Contacts(whoClose).xPos, Contacts(whoClose).yPos, Contacts(whoClose).zPos, byWhen)
MoveToClosest = TempString

End Function
Public Function FaceClosest(xPos As Double, yPos As Double, zPos As Double, byWhen As Long, whatTeam As Long) As String
Dim whoClose As Long
Dim TempString As String
whoClose = WhoClosest(xPos, yPos, zPos, whatTeam)
TempString = FacePos(Contacts(whoClose).xPos, Contacts(whoClose).yPos, Contacts(whoClose).zPos, byWhen)
FaceClosest = TempString

End Function
Public Function DistToClosest(xPos As Double, yPos As Double, zPos As Double, whatTeam As Long) As String
Dim whoClose As Long
Dim TempString As String
whoClose = WhoClosest(xPos, yPos, zPos, whatTeam)
DistToClosest = DistFromMe(xPos, yPos, zPos, whoClose)

End Function
Public Function WhereMyX(xPos As Double, goalXPos As Double, StartFrame As Long, EndFrame As Long) As Double

If StartFrame - EndFrame <> 0 Then
WhereMyX = (xPos - goalXPos) / (StartFrame - EndFrame)
Else
WhereMyX = 0
End If
End Function
Public Function WhereMyY(xPos As Double, goalXPos As Double, StartFrame As Long, EndFrame As Long) As Double
If StartFrame - EndFrame <> 0 Then
WhereMyY = (xPos - goalXPos) / (StartFrame - EndFrame)
Else
WhereMyY = 0
End If
End Function
Public Function WhereMyZ(xPos As Double, goalXPos As Double, StartFrame As Long, EndFrame As Long) As Double
If StartFrame - EndFrame <> 0 Then
WhereMyZ = (xPos - goalXPos) / (StartFrame - EndFrame)
Else
WhereMyZ = 0
End If

End Function

Public Function MovetoRandom(byWhen As Long, whatTeam As Long) As String
Dim Done As Boolean
Dim WhatGuy As Long

Do
    WhatGuy = NumContacts * Rnd(5)
    If Contacts(WhatGuy).Team = whatTeam Then
        MovetoRandom = OutputLoc(Contacts(WhatGuy).xPos, Contacts(WhatGuy).yPos, Contacts(WhatGuy).zPos, byWhen)
    End If
    Done = True
Loop Until Done = True

End Function
Public Function OneToTen() As Long
Randomize

OneToTen = Rnd(5) * 10
End Function
